<?php

class onFieldsPeriodCronExpiryCheck extends cmsAction {

    protected $useOptions = true;

    public function run(){

        if(!cmsCore::isControllerExists('billing')) { return false; }

        $ctype_name = $this->options['ctype_name'];
        $period_days = $this->options['period_days'];
        $fields_list = cmsModel::yamlToArray($this->options['fields_list']);

        $db = cmsDatabase::getInstance();

        if(!empty($fields_list)) {
            $where = '';
            foreach ($fields_list as $f) {
                $op = (empty($where)) ? "" : "OR";
                $where .= " {$op} `field` = '{$f}'";
            }

            $f_data = $db->getRows("billing_vip_fields", $where, "`id`");

            //--
            $where = '';
            foreach ($f_data as $f) {
                $op = (empty($where)) ? "" : "OR";
                $where .= " {$op} `field_id` = '{$f['id']}'";
            }

            $fields = $db->getRows("billing_vip_fields_log", $where);
        } else {
            $fields = $db->getRows("billing_vip_fields_log");
        }

        if(!empty($fields)) {
            foreach($fields as $field) {
                $start_date = strtotime($field['date_sold']);
                $end_date = $start_date + ($period_days*24*60*60);

                if(time() >= $end_date) {
                    $field_name = $db->getField("billing_vip_fields", "`id`='{$field['field_id']}'", "field");
                    $db->update("con_{$ctype_name}", "`id`='{$field['item_id']}'", array($field_name=>0));
                    $db->delete("billing_vip_fields_log", "`id`='{$field['id']}'");
                }

            }

        }

        return true;

    }

}
